<?php
// $Id$

/**
 * @file
 * Contains functions used in the Batch API deletion of nodes on uninstallation of the CONTENTdm Integration module.
 */

/**
 * Batch API 'operations' callback function that deletes nodes of type contentdm_wrapper.
 */
function contentdm_delete_nodes(&$context) {
  if (!isset($context['sandbox']['progress'])) {
    $context['sandbox']['progress'] = 0;
    $context['sandbox']['current_node'] = 0;
    $context['sandbox']['max'] = db_result(db_query('SELECT COUNT(DISTINCT nid) FROM {node} WHERE type = "contentdm_wrapper"'));
  }

  // We'll do 10 at a time.
  $limit = 10;

  // With each pass through the callback, retrieve the next group of nids.
  $result = db_query_range("SELECT nid FROM {node} WHERE nid > %d AND type = 'contentdm_wrapper' ORDER BY nid ASC", 
    $context['sandbox']['current_node'], 0, $limit);

  while ($row = db_fetch_array($result)) {
    // Delete each node.
    node_delete($row['nid']);
    // Update progress information.
    $context['results'][] = $row['nid'];
    $context['sandbox']['progress']++;
    $context['sandbox']['current_node'] = $row['nid'];
    $context['message'] = t('Deleting node ID %nid', array('%nid' => $row['nid']));
  }

  // Inform the batch engine that we are not finished, and provide an estimation of the completion level we reached.
  if ($context['sandbox']['progress'] != $context['sandbox']['max']) {
    $context['finished'] = $context['sandbox']['progress'] / $context['sandbox']['max'];
  }
}

/**
 * Batch API 'finished' callback.
 */
function contentdm_delete_nodes_finished($success, $results, $operations) {
if ($success) {
    // Here we do something meaningful with the results.
    $message = count($results) .' CONTENTdm wrapper nodes deleted.';
  }
  else {
    // An error occurred. $operations contains the operations that remained unprocessed.
    $error_operation = reset($operations);
    $message = t('An error occurred while processing %error_operation with arguments: @arguments', 
      array('%error_operation' => $error_operation[0], '@arguments' => print_r($error_operation[1], TRUE)));
  }
  drupal_set_message($message);
}
