<?php
// $Id$

/**
 * @file
 * Views functions for the CONTENTdm Integration module.
 */

/**
 * Implementation of hook_views_data(). We don't define a 'base' table since
 * contentdm_wrappers are node types, not objects.
 */
function contentdm_views_data() {
  $data['contentdm_wrapper']['table']['group'] = t('CONTENTdm wrapper');
  $data['contentdm_wrapper']['table']['join'] = array(
    // Index this array by the table name to which this table refers. 'left_field' is the primary 
    // key in the referenced table. 'field' is the foreign key in this table.
    'node' => array(
       'left_field' => 'nid',
       'field' => 'nid',
     ),
  );

  // Define the node ID field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['nid'] = array(
    'title' => t('CONTENTdm wrapper content'),
    'help' => t('Some example content that references a node.'),
    'relationship' => array(
      'base' => 'node',
      'field' => 'nid',
      'handler' => 'views_handler_relationship',
      'label' => t('CONTENTdm wrapper node'),
    ),
  );

  // Define the 'alias' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['alias'] = array(
    'title' => t('CONTENTdm "alias" value'),
    'help' => t('The CONTENTdm alias value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'pointer' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['pointer'] = array(
    'title' => t('CONTENTdm "pointer" value'),
    'help' => t('The CONTENTdm pointer value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'parent' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['parent'] = array(
    'title' => t('CONTENTdm "parent" value'),
    'help' => t('The CONTENTdm parent value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_creator' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_creator'] = array(
    'title' => t('CONTENTdm "creator" value'),
    'help' => t('The CONTENTdm dc_creator value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_date' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_date'] = array(
    'title' => t('CONTENTdm "date" value'),
    'help' => t('The CONTENTdm dc_date value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_description' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_description'] = array(
    'title' => t('CONTENTdm "description" value'),
    'help' => t('The CONTENTdm dc_description value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_type' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_type'] = array(
    'title' => t('CONTENTdm "type" value'),
    'help' => t('The CONTENTdm dc_type value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_subject' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_subject'] = array(
    'title' => t('CONTENTdm "subject" value'),
    'help' => t('The CONTENTdm dc_subject value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_contributor' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_contributor'] = array(
    'title' => t('CONTENTdm "contributor" value'),
    'help' => t('The CONTENTdm dc_contributor value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_coverage' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_coverage'] = array(
    'title' => t('CONTENTdm "coverage" value'),
    'help' => t('The CONTENTdm dc_coverage value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_format' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_format'] = array(
    'title' => t('CONTENTdm "format" value'),
    'help' => t('The CONTENTdm dc_format value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_identifier' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_identifier'] = array(
    'title' => t('CONTENTdm "identifier" value'),
    'help' => t('The CONTENTdm dc_identifier value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_publisher' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_publisher'] = array(
    'title' => t('CONTENTdm "publisher" value'),
    'help' => t('The CONTENTdm dc_publisher value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_relation' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_relation'] = array(
    'title' => t('CONTENTdm "relation" value'),
    'help' => t('The CONTENTdm dc_relation value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_rights' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_rights'] = array(
    'title' => t('CONTENTdm "rights" value'),
    'help' => t('The CONTENTdm dc_rights value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_source' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_source'] = array(
    'title' => t('CONTENTdm "source" value'),
    'help' => t('The CONTENTdm dc_source value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dc_language' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dc_language'] = array(
    'title' => t('CONTENTdm "language" value'),
    'help' => t('The CONTENTdm dc_language value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'find' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['find'] = array(
    'title' => t('CONTENTdm "find" value'),
    'help' => t('The CONTENTdm find value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dmcreated' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dmcreated'] = array(
    'title' => t('CONTENTdm "dmcreated" value'),
    'help' => t('The CONTENTdm dmcreated value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'dmmodified' field in the contentdm_wrapper table.
  $data['contentdm_wrapper']['dmmodified'] = array(
    'title' => t('CONTENTdm "dmmodified" value'),
    'help' => t('The CONTENTdm dmmodified value.'),
    'field' => array(
    'handler' => 'views_handler_field',
    'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Define the 'thumbnail' pseudo-field
  $data['contentdm_wrapper']['thumbnail'] = array(
    'title' => t('CONTENTdm thumbnail'),
    'help' => t('The CONTENTdm thumbnail image.'),
    'field' => array(
      'handler' => 'contentdm_views_handler_thumbnail',
      'additional fields' => array(
        'alias' => array(
          'table' => 'contentdm_wrapper',
          'field' => 'alias',
        ),
        'pointer' => array(
          'table' => 'contentdm_wrapper',
          'field' => 'pointer',
        ),
    ),
    ),
  );

  return $data;
}

/**
 * Implementation of hook_views_handlers().
 */
function contentdm_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'contentdm') . '/views',
    ),
    'handlers' => array(
      'contentdm_views_handler_thumbnail' => array(
        'parent' => 'views_handler_field_node',
      ),
    ),
  );
}
